/*  Client
*   This client will turn the LED on or off every 5 seconds
*/
#include <ESP8266WiFi.h>
#include <WiFiClient.h> 

#define Sound_pin 5

#define LED_A  12
#define LED_B  13
#define LED_C  15

#define Con_LED 4

#define TL_A   16
#define TL_B   14
#define TL_C   2


const char* ssid = "My_Leds";   // ssid of access point (Server)
const char* password = "microgram";    // password of access point (Server)
int port = 80;                // port number

String Received_Chars;


byte ip[]= {192,168,4,1};

int LEDstatus = 0;

uint8_t TL_A_used;
uint8_t TL_B_used;
uint8_t TL_C_used;
uint8_t Send_Request;
uint8_t Status_Copy;
uint8_t xxx;

uint8_t Led_A_req;
uint8_t Led_B_req;
uint8_t Led_C_req;
String  Data_Message;

uint16_t Loop_Counter;

uint8_t Beep_A_request;
uint8_t Beep_B_request;
uint8_t Beep_C_request;
uint8_t Beep_A_used;
uint8_t Beep_B_used;
uint8_t Beep_C_used;



WiFiClient client;  // Declare client


//...................................................... setup begin ............................................................................
void setup() 
{
    Serial.begin(115200);
	
	pinMode(Sound_pin, OUTPUT);
	digitalWrite(Sound_pin,LOW);
	
    pinMode(LED_A, OUTPUT);
	pinMode(LED_B, OUTPUT);
	pinMode(LED_C, OUTPUT);
	
	pinMode(Con_LED, OUTPUT);
	
	pinMode(0, INPUT_PULLUP);

	pinMode(TL_A, INPUT_PULLUP);
	pinMode(TL_B, INPUT_PULLUP);
	pinMode(TL_C, INPUT_PULLUP);

    WiFi.mode(WIFI_STA);  // set mode to station (client) 
    Serial.println(); 
	Serial.println();
    Serial.println("CONNECTING TO WiFi");
    WiFi.begin(ssid, password);

    while (WiFi.status() != WL_CONNECTED) 
    {
		digitalWrite(Con_LED,HIGH);
        delay(250);
		digitalWrite(Con_LED,LOW);
		delay(250);
    }
    Serial.println();
    Serial.println("WiFi CONNECTED");

	client.connect(ip, port);
}
//...................................................... setup end ............................................................................
//...................................................... loop begin ............................................................................
void loop() 
{
	Connection_Test();
	xxx = Scan_Keys();	
	Status_Copy = Status_Copy | xxx;
	Status_Eval();
	
	if (Send_Request == 1)
	{
		Send_Message();
		Send_Request = 0;
		Loop_Counter = 0;
	}
	  
    delay(100);

	Loop_Counter ++;
	if (Loop_Counter > 20)         // Control Message every 2 seconds
	{
		Loop_Counter = 0;
		Send_Control_Message();
	}
}
//.......................................................... loop end .............................................................................
//-------------------------------------------------------- Connection_Test ------------------------------------------------------------------------
void  Connection_Test(void)
{
    if (WiFi.status() == WL_CONNECTED)
	{
		digitalWrite(Con_LED,HIGH);
	}
	else
	{
		digitalWrite(Con_LED,LOW);
	}
}
//--------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------- Status_Eval ------------------------------------------------------------------------------
void  Status_Eval(void)	
{	
	if (Status_Copy != 0)
	{
		Send_Request = 1;
		
		if ((Status_Copy & 0x01) != 0)
		{
		   	Status_Copy &= 0xFE;      // vynuluj indikator
			Led_A_req = 1;
		}
		else
		{
			Led_A_req = 0;
		}
		
		if ((Status_Copy & 0x02) != 0)
		{
		   	Status_Copy &= 0xFD;      // vynuluj indikator
			Led_B_req = 1;
		}
		else
		{
			Led_B_req = 0;
		}
		
		if ((Status_Copy & 0x04) != 0)
		{
		   	Status_Copy &= 0xFB;      // vynuluj indikator
			Led_C_req = 1;
		}
		else
		{
			Led_C_req = 0;
		}
		
	}
}	
//---------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------ Send_Message ---------------------------------------------------------------------------

void  Send_Message(void)
{	  
    if (client.connect(ip, port)) 
    {
        //Serial.println("CONNECTED");
    }
    else 
    {
        //Serial.println("CONNECTION FAILED");
    }

	Data_Message = "GET /data?LED_A=";
	if (Led_A_req == 1)
	{
		Data_Message += "ON";
	}
	else
	{
		Data_Message += "OFF";
	}
	
	Data_Message += "&LED_B=";
	if (Led_B_req == 1)
	{
		Data_Message += "ON";
	}
	else
	{
		Data_Message += "OFF";
	}
	
	Data_Message += "&LED_C=";
	if (Led_C_req == 1)
	{
		Data_Message += "ON";
	}
	else
	{
		Data_Message += "OFF";
	}
	
	Data_Message += " HTTP/1.1\r\nHost: 192.268.4.1\r\Connection: close\r\n\r\n";   
	//Data_Message += " HTTP/1.1\r\nHost: 192.268.4.1\r\Connection: keep-alive\r\n\r\n"; 


    client.print(Data_Message);

    Received_Chars = client.readStringUntil('#');  
    Serial.print("Request = "); Serial.println(Received_Chars);
	Find_Leds_Status();
	
    client.flush();
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------- Send_Control_Message ------------------------------------------------------------------------------
void Send_Control_Message(void)
{
	
	if (client.connect(ip, port)) 
    {
        //Serial.println("CONNECTED");
    }
    else 
    {
        //Serial.println("CONNECTION FAILED");
    }

	Data_Message = "GET /control";
	Data_Message += " HTTP/1.1\r\nHost: 192.268.4.1\r\Connection: close\r\n\r\n";

    client.print(Data_Message);

    Received_Chars = client.readStringUntil('#');  
    Serial.print("Request = "); Serial.println(Received_Chars);
	Find_Leds_Status();
    client.flush();
	
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------ Scan_Keys ----------------------------------------------------------------------------------------
uint8_t Scan_Keys(void)
{
	uint8_t All_TL_Status = 0;
	
	if(digitalRead(TL_A) == LOW)
	{
		if(TL_A_used == 0)
		{	
		 All_TL_Status += 1; 
	     TL_A_used = 1;
		// Beep(800,300);
		 
		}
	}
	else
	{
		TL_A_used = 0;
	}
	if(digitalRead(TL_B) == LOW)
	{
		if(TL_B_used == 0)
		{
		 All_TL_Status += 2; 
	     TL_B_used = 1;
		// Beep(1000,300);
		}
	}
	else
	{
		TL_B_used = 0;
	}
	
	if(digitalRead(TL_C) == LOW)
	{
		if(TL_C_used == 0)
		{
		 All_TL_Status += 4; 
	     TL_C_used = 1;
		// Beep(1500,300);
		}
	}
	else
	{
		TL_C_used = 0;
	}
	return All_TL_Status;	
}

//---------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------------- Beep  ------------------------------------------------------------------------------------
void  Beep(uint16_t freqency, uint16_t _time)
{
		 tone(Sound_pin, freqency);
		 delay(_time);
		 noTone(Sound_pin);	
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//-------------------------------------------------- Find_Leds_Status -------------------------------------------------------------------------------
void Find_Leds_Status(void)
{	
	if (Find_Text("LED_A: 1", Received_Chars) != -1)
	{
		digitalWrite(LED_A,HIGH);
		if(Beep_A_used == 0)
		{
		Beep_A_request = 1;
		Beep(800,300);
		Beep_A_used = 1;
		}
	}
	if (Find_Text("LED_A: 0", Received_Chars) != -1)
	{
		digitalWrite(LED_A,LOW);
		Beep_A_used = 0;
	}
	
	if (Find_Text("LED_B: 1", Received_Chars) != -1)
	{
		digitalWrite(LED_B,HIGH);
		if(Beep_B_used == 0)
		{
		Beep_B_request = 1;
		Beep(1150,300);
		Beep_B_used = 1;
		}			
	}
	if (Find_Text("LED_B: 0", Received_Chars) != -1)
	{
		digitalWrite(LED_B,LOW);
		Beep_B_used = 0;
	}
	if (Find_Text("LED_C: 1", Received_Chars) != -1)
	{
		digitalWrite(LED_C,HIGH);
		if(Beep_C_used == 0)
		{
		Beep_C_request = 1;
		Beep(1500,300);
		Beep_C_used = 1;
		}	
	}
	if (Find_Text("LED_C: 0", Received_Chars) != -1)
	{
		digitalWrite(LED_C,LOW);
		Beep_C_used = 0;
	}
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
//----------------------------------------- Find_Text -----------------------------------------------------------------------------------------------
int Find_Text(String pattern, String whole_text) 
{
  int foundpos = -1;
  for (int i = 0; i <= whole_text.length() - pattern.length(); i++) 
  {
    if (whole_text.substring(i, pattern.length() + i) == pattern) 
	{
      foundpos = i;
    }
  }
  return foundpos;
}
//---------------------------------------------------------------------------------------------------------------------------------------------------
